Name:		curaengine
Epoch:		1
Version:	4.12.1
Release:	%mkrel 3
Group:		Sciences/Computer science
Summary:	Engine for processing 3D models into G-code instructions for 3D printers
License:	AGPLv3+
URL:		https://github.com/Ultimaker/CuraEngine
Source0:	https://github.com/Ultimaker/CuraEngine/archive/%{version}/curaengine-%{version}.tar.gz
# The cmake stuff would attempt to git clone this:
# TODO package on it's own
%global stb_commit af1a5bc352164740c1cc1354942b1c6b72eacb8a
Source1:	https://github.com/nothings/stb/archive/%{stb_commit}/stb-%{stb_commit}.tar.gz
Source2:	1194.patch
Source3:	1195.patch
Source4:	1196.patch
Source5:	1198.patch
Source6:	1204.patch
Source7:	1223.patch
Source8:	1236.patch
Provides:	bundled(stb) = %stb_commit

BuildRequires:	cmake
BuildRequires:	gcc-c++
BuildRequires:	git-core
BuildRequires:	libgomp-devel
BuildRequires:	libstdc++-static-devel
BuildRequires:	cmake(Arcus)
BuildRequires:	pkgconfig(polyclipping) >= 6.1.2
BuildRequires:	pkgconfig(protobuf)
BuildRequires:	pkgconfig(RapidJSON)
# For tests:
BuildRequires:	python3

%description
CuraEngine is a C++ console application for 3D printing G-code generation. It
has been made as a better and faster alternative to the old Skeinforge engine.

This is just a console application for G-code generation. For a full graphical
application look at cura which is the graphical frontend for CuraEngine.

%prep
%autosetup -p1 -S git -n CuraEngine-%{version} -a1

mv stb-%{stb_commit} stb
pushd stb
cat %{SOURCE2} | %__scm_apply_patch -p1
cat %{SOURCE3} | %__scm_apply_patch -p1
cat %{SOURCE4} | %__scm_apply_patch -p1
cat %{SOURCE5} | %__scm_apply_patch -p1
cat %{SOURCE6} | %__scm_apply_patch -p1
cat %{SOURCE7} | %__scm_apply_patch -p1
cat %{SOURCE8} | %__scm_apply_patch -p1
popd

# bundled libraries
rm -rf libs

# CXXFLAGS
sed -i \
  -e '/CMAKE_CXX_FLAGS/s/-g\s\+//g' \
  -e '/CMAKE_CXX_FLAGS/s/-O0\s\+//g' \
  CMakeLists.txt

%build
%cmake \
	-DBUILD_SHARED_LIBS:BOOL=OFF  \
	-DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
	-DCURA_ENGINE_VERSION:STRING=%{version} \
	-DVERSION:STRING=%{version} \
	-DUSE_SYSTEM_LIBS:BOOL=ON
%cmake_build

%install
%cmake_install

%check
# Smoke test
%{buildroot}%{_bindir}/CuraEngine help

%files
%doc README.md
%license LICENSE
%{_bindir}/CuraEngine


%changelog
* Thu Dec 22 2022 wally <wally> 1:4.12.1-3.mga9
+ Revision: 1925780
- rebuild for protobuf 21.12

* Wed Mar 30 2022 umeabot <umeabot> 1:4.12.1-2.mga9
+ Revision: 1834280
- Mageia 9 Mass Rebuild

* Wed Dec 29 2021 wally <wally> 1:4.12.1-1.mga9
+ Revision: 1765239
- new version 4.12.1
- rebuild for protobuf 3.19.1

* Tue Nov 16 2021 ns80 <ns80> 1:4.8.0-2.mga9
+ Revision: 1757182
- add patch curaengine-4.8.0-mga-fix-rpath-error
- stb_image: update to latest git snapshot + some pending pull requests for CVE-2021-28021, CVE-2021-42715, and CVE-2021-42716 (mga#29622)

* Mon Dec 28 2020 daviddavid <daviddavid> 1:4.8.0-1.mga8
+ Revision: 1664576
- new version: 4.8.0

* Fri Dec 18 2020 luigiwalser <luigiwalser> 1:4.4.1-4.mga8
+ Revision: 1661000
- rebuild for protobuf

* Mon Nov 30 2020 luigiwalser <luigiwalser> 1:4.4.1-3.mga8
+ Revision: 1650716
- rebuild for protobuf

* Sun Jun 28 2020 daviddavid <daviddavid> 1:4.4.1-2.mga8
+ Revision: 1600167
- rebuild for new protobuf 3.12.3

* Mon Feb 24 2020 daviddavid <daviddavid> 1:4.4.1-1.mga8
+ Revision: 1549923
- new version: 4.4.1 (add epoch as upstream changed its version scheme)
- switch to cmake build system
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 15.04-5.mga7
+ Revision: 1297374
- Mageia 7 Mass Rebuild

* Mon Sep 19 2016 akien <akien> 15.04-4.mga6
+ Revision: 1054418
- Rebuild again for polyclipping, for real this time

* Mon Sep 19 2016 akien <akien> 15.04-3.mga6
+ Revision: 1054301
- Rebuild for polyclipping 6.4

* Wed Dec 30 2015 ycantin <ycantin> 15.04-1.mga6
+ Revision: 916995
- initial import
- Created package structure for curaengine.

